package rmn;

import java.io.Serializable;

public interface Matrix extends Serializable {

  public int size();
  public int[] getDimensions();
  public Matrix getCopy();
  public Matrix newMatrix();
  public Matrix exp_avg(int n);
  public void fill(double val);
  public void inc(int[] pos);
  public void add_sub(Matrix matrix1, Matrix matrix2, double rate);
  public void add_log(Matrix matrix, int delta);
  public void dotProduct(Matrix matrix);
  public void dotProduct(double[] vector, int dim);
  public void dotQuotient(double[] vector, int dim);
  public double[] marginalize(int dim, boolean bMaximize);

  public String toString();

}
